
exception Unimplemented

type exp = Var of string 
         | Lam of string * exp
	 | Apply of exp * exp
	 | Int of int
	 | Plus of exp * exp
	 | A of exp
	 | B of exp
	 | Match of exp * string * exp * string * exp
	 | Pair of exp * exp
	 | First of exp
	 | Second of exp

(* a helper function that was useful in the Match case of translate *)
let makeLet s e1 e2 = Prob23.Apply(Prob23.Lam(s,e2,None),e1)

(******** Problem 4: complete this function ********)
let rec translate e = 
  match e with
    Int i -> Prob23.Int i
  | _ -> raise Unimplemented

(* to run a program, translate then interpret *)
let interp e = Prob23.interp1 (translate e)

(********** examples and testing ***********)

(* no need to change anything here; we have provided 1 very simply test *)

(* evaluates to Prob23.Int 7 *)
let ans1 = interp (Apply(Lam("x",
			     Match(Var "x",
				   "y", Plus(Int 3, Var "y"),
				   "z", Var "z")),
			 A(Int 4)))

let runtests () = 
  let p i = 
    print_string (match i with Prob23.Int i -> string_of_int i | _ -> "WRONG");
    print_newline () in
  p ans1
